# {{#if project_info.oas.info.title}}{{project_info.oas.info.title}}{{else}}{{project_info.project_name}}{{/if}} {{capitalize project_info.language}} Client

## Introduction
The class `ApiClient` contains all methods to consume the api. This class uses Vert.x WebClient to complete the requests. For more info give a look to [Vert.x documentation](http://vertx.io/docs/).

## How to do a request
To call an API operation you have to call the equivalent function in `ApiClient`. For more informations give a look at [operations documentation](./Operations.md).

Depending on request body declarations, you can have multiple functions for every operation:

* `operationIdWithEmptyBody`: Function that sends an empty body
* `operationIdWithJson`: Function that sends a Json body. You can pass to it a [`JsonObject`](http://vertx.io/docs/apidocs/io/vertx/core/json/JsonObject.html) or a POJO. Give a look to [WebClient documentation](http://vertx.io/docs/vertx-web-client/java/#_json_bodies) for more informations
* `operationIdWithForm`: Function that sends a form body encoded as `application/x-www-form-urlencoded`
* `operationIdWithMultipartForm`: Function that sends a form body encoded as `multipart/form-data`
* `operationIdWithContentTypeBuffer`: Function that sends a buffer with the defined content type
* `operationIdWithContentTypeStream`: Function that sends a stream with the defined content type

In every case, the `Content-Type` header is automatically configured

Every operation function also attach automatically the required headers/query/cookie parameters for the required security schemes through the `attachSecuritySchemeSecurity` functions.

For handling the responses, give a look at [WebClient documentation](http://vertx.io/docs/vertx-web-client/java/#_handling_http_responses).

## Info
This class is generated by [slush vertx](https://github.com/pmlopes/slush-vertx) generator